/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   prim_term.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PRIM_TERM_H
#define UHDM_PRIM_TERM_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class expr;

class prim_term final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(prim_term, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: prim_term();
  virtual ~prim_term() final = default;

  int32_t VpiDirection() const { return vpiDirection_; }
  bool VpiDirection(int32_t data) {
    vpiDirection_ = data;
    return true;
  }

  int32_t VpiTermIndex() const { return vpiTermIndex_; }
  bool VpiTermIndex(int32_t data) {
    vpiTermIndex_ = data;
    return true;
  }

  bool VpiValue(std::string_view data);
  std::string_view VpiValue() const;

  VectorOfattribute* Attributes() const { return attributes_; }
  bool Attributes(VectorOfattribute* data) {
    attributes_ = data;
    return true;
  }

  expr* Expr()  { return expr_; }
  const expr* Expr() const { return expr_; }
  template <typename T>
  T* Expr() {
    return (expr_ == nullptr) ? nullptr : any_cast<T*>(expr_);
  }
  template <typename T>
  const T* Expr() const {
    return (expr_ == nullptr) ? nullptr : any_cast<const T*>(expr_);
  }
  bool Expr(expr* data) {
    expr_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiPrimTerm; }

  virtual prim_term* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmprim_term; }

protected:
  void DeepCopy(prim_term* clone, BaseClass* parent, CloneContext* context) const;

private:
  int32_t vpiDirection_ = 0;

  int32_t vpiTermIndex_ = 0;

  SymbolId vpiValue_;

  VectorOfattribute* attributes_ = nullptr;

  expr* expr_ = nullptr;
};


typedef FactoryT<prim_term> prim_termFactory;


typedef FactoryT<std::vector<prim_term *>> VectorOfprim_termFactory;

}  // namespace UHDM

#endif
