/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   program.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PROGRAM_H
#define UHDM_PROGRAM_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/instance.h>

#include "expr_dist.h"


namespace UHDM {
class clocking_block;
class instance_array;

class program final : public instance {
  UHDM_IMPLEMENT_RTTI(program, instance)
public:
  // Implicit constructor used to initialize all members,
  // comment: program();
  virtual ~program() final = default;

  int32_t VpiIndex() const { return vpiIndex_; }
  bool VpiIndex(int32_t data) {
    vpiIndex_ = data;
    return true;
  }

  uint32_t VpiType() const final { return vpiProgram; }

  clocking_block* Default_clocking()  { return default_clocking_; }
  const clocking_block* Default_clocking() const { return default_clocking_; }
  template <typename T>
  T* Default_clocking() {
    return (default_clocking_ == nullptr) ? nullptr : any_cast<T*>(default_clocking_);
  }
  template <typename T>
  const T* Default_clocking() const {
    return (default_clocking_ == nullptr) ? nullptr : any_cast<const T*>(default_clocking_);
  }
  bool Default_clocking(clocking_block* data) {
    default_clocking_ = data;
    return true;
  }

  instance_array* Instance_array()  { return instance_array_; }
  const instance_array* Instance_array() const { return instance_array_; }
  template <typename T>
  T* Instance_array() {
    return (instance_array_ == nullptr) ? nullptr : any_cast<T*>(instance_array_);
  }
  template <typename T>
  const T* Instance_array() const {
    return (instance_array_ == nullptr) ? nullptr : any_cast<const T*>(instance_array_);
  }
  bool Instance_array(instance_array* data) {
    instance_array_ = data;
    return true;
  }

  VectorOfinterface_inst* Interfaces() const { return interfaces_; }
  bool Interfaces(VectorOfinterface_inst* data) {
    interfaces_ = data;
    return true;
  }

  any* Expr_dist()  { return expr_dist_; }
  const any* Expr_dist() const { return expr_dist_; }
  template <typename T>
  T* Expr_dist() {
    return (expr_dist_ == nullptr) ? nullptr : any_cast<T*>(expr_dist_);
  }
  template <typename T>
  const T* Expr_dist() const {
    return (expr_dist_ == nullptr) ? nullptr : any_cast<const T*>(expr_dist_);
  }
  bool Expr_dist(any* data) {
    if (!expr_distGroupCompliant(data)) return false;
    expr_dist_ = data;
    return true;
  }

  VectorOfinterface_array* Interface_arrays() const { return interface_arrays_; }
  bool Interface_arrays(VectorOfinterface_array* data) {
    interface_arrays_ = data;
    return true;
  }

  VectorOfprocess_stmt* Process() const { return process_; }
  bool Process(VectorOfprocess_stmt* data) {
    process_ = data;
    return true;
  }

  VectorOfcont_assign* Cont_assigns() const { return cont_assigns_; }
  bool Cont_assigns(VectorOfcont_assign* data) {
    cont_assigns_ = data;
    return true;
  }

  VectorOfclocking_block* Clocking_blocks() const { return clocking_blocks_; }
  bool Clocking_blocks(VectorOfclocking_block* data) {
    clocking_blocks_ = data;
    return true;
  }

  VectorOfport* Ports() const { return ports_; }
  bool Ports(VectorOfport* data) {
    ports_ = data;
    return true;
  }

  VectorOfgen_scope_array* Gen_scope_arrays() const { return gen_scope_arrays_; }
  bool Gen_scope_arrays(VectorOfgen_scope_array* data) {
    gen_scope_arrays_ = data;
    return true;
  }

  bool VpiEndLabel(std::string_view data);
  std::string_view VpiEndLabel() const;

  virtual program* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmprogram; }

protected:
  void DeepCopy(program* clone, BaseClass* parent, CloneContext* context) const;

private:
  int32_t vpiIndex_ = 0;

  clocking_block* default_clocking_ = nullptr;

  instance_array* instance_array_ = nullptr;

  VectorOfinterface_inst* interfaces_ = nullptr;

  any* expr_dist_ = nullptr;

  VectorOfinterface_array* interface_arrays_ = nullptr;

  VectorOfprocess_stmt* process_ = nullptr;

  VectorOfcont_assign* cont_assigns_ = nullptr;

  VectorOfclocking_block* clocking_blocks_ = nullptr;

  VectorOfport* ports_ = nullptr;

  VectorOfgen_scope_array* gen_scope_arrays_ = nullptr;

  SymbolId vpiEndLabel_;
};


typedef FactoryT<program> programFactory;


typedef FactoryT<std::vector<program *>> VectorOfprogramFactory;

}  // namespace UHDM

#endif
