/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   type_parameter.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TYPE_PARAMETER_H
#define UHDM_TYPE_PARAMETER_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/typespec.h>




namespace UHDM {
class ref_typespec;

class type_parameter final : public typespec {
  UHDM_IMPLEMENT_RTTI(type_parameter, typespec)
public:
  // Implicit constructor used to initialize all members,
  // comment: type_parameter();
  virtual ~type_parameter() final = default;

  bool VpiLocalParam() const { return vpiLocalParam_; }
  bool VpiLocalParam(bool data) {
    vpiLocalParam_ = data;
    return true;
  }

  bool VpiFullName(std::string_view data);
  std::string_view VpiFullName() const;

  ref_typespec* Typespec()  { return typespec_; }
  const ref_typespec* Typespec() const { return typespec_; }
  template <typename T>
  T* Typespec() {
    return (typespec_ == nullptr) ? nullptr : any_cast<T*>(typespec_);
  }
  template <typename T>
  const T* Typespec() const {
    return (typespec_ == nullptr) ? nullptr : any_cast<const T*>(typespec_);
  }
  bool Typespec(ref_typespec* data) {
    typespec_ = data;
    return true;
  }

  ref_typespec* Expr()  { return expr_; }
  const ref_typespec* Expr() const { return expr_; }
  template <typename T>
  T* Expr() {
    return (expr_ == nullptr) ? nullptr : any_cast<T*>(expr_);
  }
  template <typename T>
  const T* Expr() const {
    return (expr_ == nullptr) ? nullptr : any_cast<const T*>(expr_);
  }
  bool Expr(ref_typespec* data) {
    expr_ = data;
    return true;
  }

  bool VpiImported(std::string_view data);
  std::string_view VpiImported() const;

  virtual uint32_t VpiType() const final { return vpiTypeParameter; }

  virtual type_parameter* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmtype_parameter; }

protected:
  void DeepCopy(type_parameter* clone, BaseClass* parent, CloneContext* context) const;

private:
  bool vpiLocalParam_ = false;

  SymbolId vpiFullName_;

  ref_typespec* typespec_ = nullptr;

  ref_typespec* expr_ = nullptr;

  SymbolId vpiImported_;
};


typedef FactoryT<type_parameter> type_parameterFactory;


typedef FactoryT<std::vector<type_parameter *>> VectorOftype_parameterFactory;

}  // namespace UHDM

#endif
