/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   typespec.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_TYPESPEC_H
#define UHDM_TYPESPEC_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class instance;
class ref_typespec;

class typespec : public BaseClass {
  UHDM_IMPLEMENT_RTTI(typespec, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: typespec();
  virtual ~typespec() = default;

  virtual bool VpiName(std::string_view data) final;
  virtual std::string_view VpiName() const final;

  ref_typespec* Typedef_alias()  { return typedef_alias_; }
  const ref_typespec* Typedef_alias() const { return typedef_alias_; }
  template <typename T>
  T* Typedef_alias() {
    return (typedef_alias_ == nullptr) ? nullptr : any_cast<T*>(typedef_alias_);
  }
  template <typename T>
  const T* Typedef_alias() const {
    return (typedef_alias_ == nullptr) ? nullptr : any_cast<const T*>(typedef_alias_);
  }
  bool Typedef_alias(ref_typespec* data) {
    typedef_alias_ = data;
    return true;
  }

  instance* Instance()  { return instance_; }
  const instance* Instance() const { return instance_; }
  template <typename T>
  T* Instance() {
    return (instance_ == nullptr) ? nullptr : any_cast<T*>(instance_);
  }
  template <typename T>
  const T* Instance() const {
    return (instance_ == nullptr) ? nullptr : any_cast<const T*>(instance_);
  }
  bool Instance(instance* data) {
    instance_ = data;
    return true;
  }

  virtual typespec* DeepClone(BaseClass* parent, CloneContext* context) const override = 0;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const override { return UHDM_OBJECT_TYPE::uhdmtypespec; }

protected:
  void DeepCopy(typespec* clone, BaseClass* parent, CloneContext* context) const;

private:
  SymbolId vpiName_;

  ref_typespec* typedef_alias_ = nullptr;

  instance* instance_ = nullptr;
};

#if 0 // This class cannot be instantiated
typedef FactoryT<typespec> typespecFactory;
#endif

typedef FactoryT<std::vector<typespec *>> VectorOftypespecFactory;

}  // namespace UHDM

#endif
